(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tslib'), require('@angular/core'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define(['exports', 'tslib', '@angular/core', 'rxjs'], factory) :
    (global = global || self, factory(global['common-ui-angular'] = {}, global.tslib_1, global.core, global.rxjs));
}(this, (function (exports, tslib_1, core, rxjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    const proxyInputs = (/**
     * @param {?} Cmp
     * @param {?} inputs
     * @return {?}
     */
    (Cmp, inputs) => {
        /** @type {?} */
        const Prototype = Cmp.prototype;
        inputs.forEach((/**
         * @param {?} item
         * @return {?}
         */
        item => {
            Object.defineProperty(Prototype, item, {
                /**
                 * @return {?}
                 */
                get() {
                    return this.el[item];
                },
                /**
                 * @param {?} val
                 * @return {?}
                 */
                set(val) {
                    this.z.runOutsideAngular((/**
                     * @return {?}
                     */
                    () => (this.el[item] = val)));
                }
            });
        }));
    });
    /** @type {?} */
    const proxyMethods = (/**
     * @param {?} Cmp
     * @param {?} methods
     * @return {?}
     */
    (Cmp, methods) => {
        /** @type {?} */
        const Prototype = Cmp.prototype;
        methods.forEach((/**
         * @param {?} methodName
         * @return {?}
         */
        methodName => {
            Prototype[methodName] = (/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                const args = arguments;
                return this.z.runOutsideAngular((/**
                 * @return {?}
                 */
                () => this.el[methodName].apply(this.el, args)));
            });
        }));
    });
    /** @type {?} */
    const proxyOutputs = (/**
     * @param {?} instance
     * @param {?} el
     * @param {?} events
     * @return {?}
     */
    (instance, el, events) => {
        events.forEach((/**
         * @param {?} eventName
         * @return {?}
         */
        eventName => instance[eventName] = rxjs.fromEvent(el, eventName)));
    });
    /**
     * @param {?} opts
     * @return {?}
     */
    function ProxyCmp(opts) {
        /** @type {?} */
        const decorator = (/**
         * @param {?} cls
         * @return {?}
         */
        function (cls) {
            if (opts.inputs) {
                proxyInputs(cls, opts.inputs);
            }
            if (opts.methods) {
                proxyMethods(cls, opts.methods);
            }
            return cls;
        });
        return decorator;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    exports.CmBanner = class CmBanner {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmBanner.decorators = [
        { type: core.Component, args: [{ selector: "cm-banner", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance"] },] },
    ];
    /** @nocollapse */
    exports.CmBanner.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmBanner = tslib_1.__decorate([
        ProxyCmp({ inputs: ["appearance"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmBanner);
    exports.CmButton = class CmButton {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmPress"]);
        }
    };
    exports.CmButton.decorators = [
        { type: core.Component, args: [{ selector: "cm-button", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "disabled", "label", "loading", "size"] },] },
    ];
    /** @nocollapse */
    exports.CmButton.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmButton = tslib_1.__decorate([
        ProxyCmp({ inputs: ["appearance", "disabled", "label", "loading", "size"], "methods": ["press"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmButton);
    exports.CmCard = class CmCard {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmDismissed"]);
        }
    };
    exports.CmCard.decorators = [
        { type: core.Component, args: [{ selector: "cm-card", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["isDismissable"] },] },
    ];
    /** @nocollapse */
    exports.CmCard.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmCard = tslib_1.__decorate([
        ProxyCmp({ inputs: ["isDismissable"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmCard);
    exports.CmCheckbox = class CmCheckbox {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput"]);
        }
    };
    exports.CmCheckbox.decorators = [
        { type: core.Component, args: [{ selector: "cm-checkbox", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["checked", "disabled", "enableAttributeEmit", "formName", "helperText", "icon", "indeterminate", "label", "required"] },] },
    ];
    /** @nocollapse */
    exports.CmCheckbox.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmCheckbox = tslib_1.__decorate([
        ProxyCmp({ inputs: ["checked", "disabled", "enableAttributeEmit", "formName", "helperText", "icon", "indeterminate", "label", "required"], "methods": ["toggleCheck", "check", "uncheck", "reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmCheckbox);
    exports.CmCheckboxGroup = class CmCheckboxGroup {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmCheckboxGroup.decorators = [
        { type: core.Component, args: [{ selector: "cm-checkbox-group", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label"] },] },
    ];
    /** @nocollapse */
    exports.CmCheckboxGroup.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmCheckboxGroup = tslib_1.__decorate([
        ProxyCmp({ inputs: ["label"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmCheckboxGroup);
    exports.CmContext = class CmContext {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["themeChanged"]);
        }
    };
    exports.CmContext.decorators = [
        { type: core.Component, args: [{ selector: "cm-context", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["theme"] },] },
    ];
    /** @nocollapse */
    exports.CmContext.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmContext = tslib_1.__decorate([
        ProxyCmp({ inputs: ["theme"], "methods": ["getVariableValue", "getResolvedTheme"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmContext);
    exports.CmDatalist = class CmDatalist {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmDatalist.decorators = [
        { type: core.Component, args: [{ selector: "cm-datalist", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["headline", "labelWidth"] },] },
    ];
    /** @nocollapse */
    exports.CmDatalist.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmDatalist = tslib_1.__decorate([
        ProxyCmp({ inputs: ["headline", "labelWidth"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmDatalist);
    exports.CmDatalistItem = class CmDatalistItem {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmDatalistItem.decorators = [
        { type: core.Component, args: [{ selector: "cm-datalist-item", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label", "labelWidth"] },] },
    ];
    /** @nocollapse */
    exports.CmDatalistItem.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmDatalistItem = tslib_1.__decorate([
        ProxyCmp({ inputs: ["label", "labelWidth"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmDatalistItem);
    exports.CmDropdown = class CmDropdown {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmDropdown.decorators = [
        { type: core.Component, args: [{ selector: "cm-dropdown", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["options", "trigger"] },] },
    ];
    /** @nocollapse */
    exports.CmDropdown.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmDropdown = tslib_1.__decorate([
        ProxyCmp({ inputs: ["options", "trigger"], "methods": ["open", "close", "triggerOptionByIndex"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmDropdown);
    exports.CmEntityList = class CmEntityList {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmEntityList.decorators = [
        { type: core.Component, args: [{ selector: "cm-entity-list", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["addScrollPadding", "columns", "createButtonDataAttributes", "createButtonLabel", "createHandler", "defaultSorting", "enableCreateButton", "entities", "groupOptions", "headline", "hideCreateButton", "hideSearch", "loading"] },] },
    ];
    /** @nocollapse */
    exports.CmEntityList.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmEntityList = tslib_1.__decorate([
        ProxyCmp({ inputs: ["addScrollPadding", "columns", "createButtonDataAttributes", "createButtonLabel", "createHandler", "defaultSorting", "enableCreateButton", "entities", "groupOptions", "headline", "hideCreateButton", "hideSearch", "loading"], "methods": ["triggerEntityOption", "triggerGroupOption", "selectAll", "deselectAll", "selectIndex", "deselectIndex"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmEntityList);
    exports.CmFilter = class CmFilter {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmFilterSelected"]);
        }
    };
    exports.CmFilter.decorators = [
        { type: core.Component, args: [{ selector: "cm-filter", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["activeFilterIndex", "filters"] },] },
    ];
    /** @nocollapse */
    exports.CmFilter.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmFilter = tslib_1.__decorate([
        ProxyCmp({ inputs: ["activeFilterIndex", "filters"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmFilter);
    exports.CmFooter = class CmFooter {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmFooter.decorators = [
        { type: core.Component, args: [{ selector: "cm-footer", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["text"] },] },
    ];
    /** @nocollapse */
    exports.CmFooter.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmFooter = tslib_1.__decorate([
        ProxyCmp({ inputs: ["text"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmFooter);
    exports.CmForm = class CmForm {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmSubmit"]);
        }
    };
    exports.CmForm.decorators = [
        { type: core.Component, args: [{ selector: "cm-form", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
    ];
    /** @nocollapse */
    exports.CmForm.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmForm = tslib_1.__decorate([
        ProxyCmp({ "methods": ["checkValidity", "getFormData", "attemptSubmit", "reset", "forceFocus"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmForm);
    exports.CmFormGroup = class CmFormGroup {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmFormGroup.decorators = [
        { type: core.Component, args: [{ selector: "cm-form-group", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["label"] },] },
    ];
    /** @nocollapse */
    exports.CmFormGroup.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmFormGroup = tslib_1.__decorate([
        ProxyCmp({ inputs: ["label"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmFormGroup);
    class CmHeader {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    }
    CmHeader.decorators = [
        { type: core.Component, args: [{ selector: "cm-header", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
    ];
    /** @nocollapse */
    CmHeader.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmIcon = class CmIcon {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmIcon.decorators = [
        { type: core.Component, args: [{ selector: "cm-icon", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["color", "icon", "ignoreTheme"] },] },
    ];
    /** @nocollapse */
    exports.CmIcon.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmIcon = tslib_1.__decorate([
        ProxyCmp({ inputs: ["color", "icon", "ignoreTheme"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmIcon);
    exports.CmIconButton = class CmIconButton {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmPress"]);
        }
    };
    exports.CmIconButton.decorators = [
        { type: core.Component, args: [{ selector: "cm-icon-button", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["color", "disabled", "icon", "ignoreTheme"] },] },
    ];
    /** @nocollapse */
    exports.CmIconButton.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmIconButton = tslib_1.__decorate([
        ProxyCmp({ inputs: ["color", "disabled", "icon", "ignoreTheme"], "methods": ["press"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmIconButton);
    exports.CmLink = class CmLink {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmLink.decorators = [
        { type: core.Component, args: [{ selector: "cm-link", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["href", "label", "openIn"] },] },
    ];
    /** @nocollapse */
    exports.CmLink.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmLink = tslib_1.__decorate([
        ProxyCmp({ inputs: ["href", "label", "openIn"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmLink);
    exports.CmLoader = class CmLoader {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmLoader.decorators = [
        { type: core.Component, args: [{ selector: "cm-loader", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["size"] },] },
    ];
    /** @nocollapse */
    exports.CmLoader.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmLoader = tslib_1.__decorate([
        ProxyCmp({ inputs: ["size"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmLoader);
    class CmLogo {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    }
    CmLogo.decorators = [
        { type: core.Component, args: [{ selector: "cm-logo", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
    ];
    /** @nocollapse */
    CmLogo.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmModal = class CmModal {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmModal.decorators = [
        { type: core.Component, args: [{ selector: "cm-modal", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["cancelAppearance", "cancelButtonDataAttributes", "cancelLabel", "closeButtonDataAttributes", "confirmAppearance", "confirmButtonDataAttributes", "confirmDisabled", "confirmLabel", "headline", "overrideMaximumWidth", "paddings", "position", "width"] },] },
    ];
    /** @nocollapse */
    exports.CmModal.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmModal = tslib_1.__decorate([
        ProxyCmp({ inputs: ["cancelAppearance", "cancelButtonDataAttributes", "cancelLabel", "closeButtonDataAttributes", "confirmAppearance", "confirmButtonDataAttributes", "confirmDisabled", "confirmLabel", "headline", "overrideMaximumWidth", "paddings", "position", "width"], "methods": ["open", "confirm", "cancel"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmModal);
    exports.CmNotification = class CmNotification {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmDismissed", "cmNotificationNavigation", "didLoad"]);
        }
    };
    exports.CmNotification.decorators = [
        { type: core.Component, args: [{ selector: "cm-notification", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "createdAt", "description", "headline", "navigationLabel", "showCreationTime", "userDismissable"] },] },
    ];
    /** @nocollapse */
    exports.CmNotification.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmNotification = tslib_1.__decorate([
        ProxyCmp({ inputs: ["appearance", "createdAt", "description", "headline", "navigationLabel", "showCreationTime", "userDismissable"], "methods": ["dismiss", "isBeingHovered"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmNotification);
    exports.CmNotificationContainer = class CmNotificationContainer {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmNotificationContainer.decorators = [
        { type: core.Component, args: [{ selector: "cm-notification-container", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>" },] },
    ];
    /** @nocollapse */
    exports.CmNotificationContainer.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmNotificationContainer = tslib_1.__decorate([
        ProxyCmp({ "methods": ["enqueueNotification"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmNotificationContainer);
    exports.CmPage = class CmPage {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["tabChanged"]);
        }
    };
    exports.CmPage.decorators = [
        { type: core.Component, args: [{ selector: "cm-page", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["activeLabel"] },] },
    ];
    /** @nocollapse */
    exports.CmPage.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmPage = tslib_1.__decorate([
        ProxyCmp({ inputs: ["activeLabel"], "methods": ["getActiveState", "switchToTab", "switchToTabIndex"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmPage);
    exports.CmPageTab = class CmPageTab {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["tabModified"]);
        }
    };
    exports.CmPageTab.decorators = [
        { type: core.Component, args: [{ selector: "cm-page-tab", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["active", "disableScroll", "label"] },] },
    ];
    /** @nocollapse */
    exports.CmPageTab.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmPageTab = tslib_1.__decorate([
        ProxyCmp({ inputs: ["active", "disableScroll", "label"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmPageTab);
    exports.CmPageTabHandle = class CmPageTabHandle {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["userSelectedTab"]);
        }
    };
    exports.CmPageTabHandle.decorators = [
        { type: core.Component, args: [{ selector: "cm-page-tab-handle", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["active", "label"] },] },
    ];
    /** @nocollapse */
    exports.CmPageTabHandle.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmPageTabHandle = tslib_1.__decorate([
        ProxyCmp({ inputs: ["active", "label"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmPageTabHandle);
    exports.CmRadiobutton = class CmRadiobutton {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmSelected"]);
        }
    };
    exports.CmRadiobutton.decorators = [
        { type: core.Component, args: [{ selector: "cm-radiobutton", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["disabled", "helperText", "label", "selected", "value"] },] },
    ];
    /** @nocollapse */
    exports.CmRadiobutton.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmRadiobutton = tslib_1.__decorate([
        ProxyCmp({ inputs: ["disabled", "helperText", "label", "selected", "value"], "methods": ["select"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmRadiobutton);
    exports.CmRadiobuttonGroup = class CmRadiobuttonGroup {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput"]);
        }
    };
    exports.CmRadiobuttonGroup.decorators = [
        { type: core.Component, args: [{ selector: "cm-radiobutton-group", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["formName", "label", "value"] },] },
    ];
    /** @nocollapse */
    exports.CmRadiobuttonGroup.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmRadiobuttonGroup = tslib_1.__decorate([
        ProxyCmp({ inputs: ["formName", "label", "value"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmRadiobuttonGroup);
    exports.CmSelect = class CmSelect {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput", "cmReset"]);
        }
    };
    exports.CmSelect.decorators = [
        { type: core.Component, args: [{ selector: "cm-select", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["allowMultiple", "disabled", "fieldPrefix", "formName", "helperText", "label", "labelAlignment", "options", "placeholder", "preventVerticalExpansion", "required", "selectedOptions", "showRequired", "validation", "validationStyle"] },] },
    ];
    /** @nocollapse */
    exports.CmSelect.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmSelect = tslib_1.__decorate([
        ProxyCmp({ inputs: ["allowMultiple", "disabled", "fieldPrefix", "formName", "helperText", "label", "labelAlignment", "options", "placeholder", "preventVerticalExpansion", "required", "selectedOptions", "showRequired", "validation", "validationStyle"], "methods": ["reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmSelect);
    exports.CmSelectFlyout = class CmSelectFlyout {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput"]);
        }
    };
    exports.CmSelectFlyout.decorators = [
        { type: core.Component, args: [{ selector: "cm-select-flyout", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["isOpen", "options", "select", "selectedOptions"] },] },
    ];
    /** @nocollapse */
    exports.CmSelectFlyout.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmSelectFlyout = tslib_1.__decorate([
        ProxyCmp({ inputs: ["isOpen", "options", "select", "selectedOptions"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmSelectFlyout);
    exports.CmText = class CmText {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
        }
    };
    exports.CmText.decorators = [
        { type: core.Component, args: [{ selector: "cm-text", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["appearance", "color"] },] },
    ];
    /** @nocollapse */
    exports.CmText.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmText = tslib_1.__decorate([
        ProxyCmp({ inputs: ["appearance", "color"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmText);
    exports.CmTextfield = class CmTextfield {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput", "cmReset"]);
        }
    };
    exports.CmTextfield.decorators = [
        { type: core.Component, args: [{ selector: "cm-textfield", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["autocomplete", "disabled", "fieldPrefix", "fieldSuffix", "formName", "helperText", "label", "labelAlignment", "max", "maxLength", "min", "placeholder", "required", "rows", "showRequired", "step", "type", "validation", "validationStyle", "value", "valueAsNumber"] },] },
    ];
    /** @nocollapse */
    exports.CmTextfield.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmTextfield = tslib_1.__decorate([
        ProxyCmp({ inputs: ["autocomplete", "disabled", "fieldPrefix", "fieldSuffix", "formName", "helperText", "label", "labelAlignment", "max", "maxLength", "min", "placeholder", "required", "rows", "showRequired", "step", "type", "validation", "validationStyle", "value", "valueAsNumber"], "methods": ["reset", "forceFocus", "checkValidity", "renderValidity", "hideValidity"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmTextfield);
    exports.CmToggle = class CmToggle {
        /**
         * @param {?} c
         * @param {?} r
         * @param {?} z
         */
        constructor(c, r, z) {
            this.z = z;
            c.detach();
            this.el = r.nativeElement;
            proxyOutputs(this, this.el, ["cmInput"]);
        }
    };
    exports.CmToggle.decorators = [
        { type: core.Component, args: [{ selector: "cm-toggle", changeDetection: core.ChangeDetectionStrategy.OnPush, template: "<ng-content></ng-content>", inputs: ["checked", "disabled", "enableAttributeEmit", "label"] },] },
    ];
    /** @nocollapse */
    exports.CmToggle.ctorParameters = () => [
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone }
    ];
    exports.CmToggle = tslib_1.__decorate([
        ProxyCmp({ inputs: ["checked", "disabled", "enableAttributeEmit", "label"], "methods": ["toggleCheck", "check", "uncheck"] }),
        tslib_1.__metadata("design:paramtypes", [core.ChangeDetectorRef, core.ElementRef, core.NgZone])
    ], exports.CmToggle);

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    const DECLARATIONS = [
        exports.CmBanner,
        exports.CmIconButton,
        exports.CmContext,
        exports.CmLoader,
        exports.CmButton,
        exports.CmCheckbox,
        exports.CmToggle,
        exports.CmSelect,
        exports.CmSelectFlyout,
        exports.CmLink,
        exports.CmText,
        exports.CmFooter,
        CmHeader,
        exports.CmIcon,
        exports.CmModal,
        CmLogo,
        exports.CmPage,
        exports.CmPageTab,
        exports.CmPageTabHandle,
        exports.CmDatalist,
        exports.CmDatalistItem,
        exports.CmNotification,
        exports.CmNotificationContainer,
        exports.CmEntityList,
        exports.CmDropdown,
        exports.CmCard,
        exports.CmFilter,
        exports.CmRadiobutton,
        exports.CmRadiobuttonGroup,
        exports.CmForm,
        exports.CmFormGroup,
        exports.CmCheckboxGroup,
        exports.CmTextfield,
    ];
    class CommonUiModule {
    }
    CommonUiModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: DECLARATIONS,
                    exports: DECLARATIONS,
                    imports: [],
                    providers: [],
                },] },
    ];

    exports.CmHeader = CmHeader;
    exports.CmLogo = CmLogo;
    exports.CommonUiModule = CommonUiModule;
    exports.ɵa = ProxyCmp;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
